package com.zhongzheng.modules.activity.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.modules.activity.bo.ActivityTaskUserAddBo;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.activity.bo.ActivityTaskTimeAddBo;
import com.zhongzheng.modules.activity.bo.ActivityTaskTimeQueryBo;
import com.zhongzheng.modules.activity.bo.ActivityTaskTimeEditBo;
import com.zhongzheng.modules.activity.domain.ActivityTaskTime;
import com.zhongzheng.modules.activity.mapper.ActivityTaskTimeMapper;
import com.zhongzheng.modules.activity.vo.ActivityTaskTimeVo;
import com.zhongzheng.modules.activity.service.IActivityTaskTimeService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 模拟考试分数给予积分关联Service业务层处理
 *
 * @author change
 * @date 2021-05-20
 */
@Service
public class ActivityTaskTimeServiceImpl extends ServiceImpl<ActivityTaskTimeMapper, ActivityTaskTime> implements IActivityTaskTimeService {

    @Override
    public ActivityTaskTimeVo queryById(Long taskId){
        ActivityTaskTime db = this.baseMapper.selectById(taskId);
        return BeanUtil.toBean(db, ActivityTaskTimeVo.class);
    }

    @Override
    public List<ActivityTaskTimeVo> queryList(ActivityTaskTimeQueryBo bo) {
        LambdaQueryWrapper<ActivityTaskTime> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getStartRange() != null, ActivityTaskTime::getStartRange, bo.getStartRange());
        lqw.eq(bo.getEndRange() != null, ActivityTaskTime::getEndRange, bo.getEndRange());
        lqw.eq(bo.getIntegral() != null, ActivityTaskTime::getIntegral, bo.getIntegral());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<ActivityTaskTimeVo> entity2Vo(Collection<ActivityTaskTime> collection) {
        List<ActivityTaskTimeVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, ActivityTaskTimeVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<ActivityTaskTime> page = (Page<ActivityTaskTime>)collection;
            Page<ActivityTaskTimeVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(ActivityTaskTimeAddBo bo) {
        ActivityTaskTime add = BeanUtil.toBean(bo, ActivityTaskTime.class);
        validEntityBeforeSave(add);
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(ActivityTaskTimeEditBo bo) {
        ActivityTaskTime update = BeanUtil.toBean(bo, ActivityTaskTime.class);
        validEntityBeforeSave(update);
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(ActivityTaskTime entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }

    @Override
    public void inserTaskTime(ActivityTaskTime toBean) {
        baseMapper.inserTaskTime(toBean);
    }

    @Override
    public ActivityTaskTimeVo queryPractice(ActivityTaskUserAddBo bo) {
        return baseMapper.queryPractice(bo);
    }
}
